VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 2  'RequiresTransaction
END
Attribute VB_Name = "Transfer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Implements ObjectControl

Dim m_pIObjectContext As ObjectContext
Const k_strDSN As String = _
"provider=sqloledb;server=watson;database=books;" & _
"uid=sa;password="

Private Sub ObjectControl_Activate()
    Set m_pIObjectContext = GetObjectContext()
End Sub

Private Sub ObjectControl_Deactivate()
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
    ObjectControl_CanBePooled = False
End Function

' Helper function for inserting strings into SQL statements
Private Function PrepareSQLParameter(ByVal strParam As String) As String
    strParam = Replace(strParam, "'", "''")
    strParam = "'" & strParam & "'"
    PrepareSQLParameter = strParam
End Function

Public Sub MoveFromDatabaseToQueue(ByVal strTitle As Variant, ByVal strQueueName As Variant)
    Dim objRS As ADODB.Recordset
    Dim objStream As ADODB.Stream
    Dim strSQL As String

    Dim objMQInfo As MSMQ.MSMQQueueInfo
    Dim objMQQueue As MSMQ.MSMQQueue
    Dim objMQMessage As MSMQ.MSMQMessage

    strSQL = "EXEC spSelectBookByTitleAndRemove " & PrepareSQLParameter(strTitle)

    On Error GoTo ErrorHandler
        Set objRS = CreateObject("ADODB.Recordset")
        Set objStream = CreateObject("ADODB.Stream")

        Call objRS.Open(strSQL, k_strDSN, adOpenForwardOnly, adLockReadOnly, adCmdText)

        Call objRS.Save(objStream, adPersistXML)

        Call objRS.Close

        Set objMQInfo = CreateObject("MSMQ.MSMQQueueInfo")
        objMQInfo.PathName = strQueueName

' From MSDN: To open a queue when sending messages,
' the queue's access mode must be set to MQ_SEND_ACCESS,
' and the queue's share mode must be set to MQ_DENY_NONE.
        Set objMQQueue = objMQInfo.Open(MSMQ.MQ_SEND_ACCESS, _
        MSMQ.MQ_DENY_NONE)

        Set objMQMessage = CreateObject("MSMQ.MSMQMessage")
        objMQMessage.Label = strTitle
        objMQMessage.Body = objStream.ReadText

        Call objMQMessage.Send(objMQQueue, _
        MSMQ.MQ_MTS_TRANSACTION)

        Call objMQQueue.Close

        Call m_pIObjectContext.SetComplete
        Exit Sub

ErrorHandler:
    Call m_pIObjectContext.SetAbort

    If objRS.ActiveConnection.Errors.Count > 0 Then
        With objRS.ActiveConnection.Errors(0)
            Call Err.Raise(.Number, .Source, .Description)
        End With
    Else
        With Err
            Call .Raise(.Number, .Source, .Description)
        End With
    End If

End Sub

Public Sub MoveFromQueueToDatabase(ByVal strTitle As Variant, ByVal strQueueName As Variant)
    Dim objMQInfo As MSMQ.MSMQQueueInfo
    Dim objMQQueue As MSMQ.MSMQQueue
    Dim objMQMessage As MSMQ.MSMQMessage

    Dim objRSRead As ADODB.Recordset
    Dim objRSInsert As ADODB.Recordset
    Dim objField As ADODB.Field
    Dim objStream As ADODB.Stream

    On Error GoTo ErrorHandler
        Set objMQInfo = CreateObject("MSMQ.MSMQQueueInfo")
        objMQInfo.PathName = strQueueName

' From MSDN: When opening a queue to read messages, the
' queue's share mode can be set to MQ_DENY_NONE or
' MQ_DENY_SHARE_RECEIVE. When peeking at the messages in
' the queue, MQ_DENY_NONE must be specified. When
' retrieving messages, either setting can be used.

' In this case, we want to peek at messages until we
' find the one we're looking for, then we'll receive it.
' We can specify receive access, because it includes peek
' access.
        Set objMQQueue = objMQInfo.Open(MSMQ.MQ_RECEIVE_ACCESS, MSMQ.MQ_DENY_RECEIVE_SHARE)

        Set objMQMessage = objMQQueue.PeekCurrent(False, False, 30)
        Do Until objMQMessage Is Nothing
            If 0 = StrComp(objMQMessage.Label, strTitle, vbTextCompare) Then
                Exit Do
            End If

            Set objMQMessage = objMQQueue.PeekNext(False, False, 30)
        Loop

        If objMQMessage Is Nothing Then
            Err.Raise "No such book"
        End If

        Set objMQMessage = objMQQueue.ReceiveCurrent(MSMQ.MQ_MTS_TRANSACTION, False, True, 30)

        Call objMQQueue.Close

        Set objRSRead = CreateObject("ADODB.Recordset")
        Set objRSInsert = CreateObject("ADODB.Recordset")
        Set objStream = CreateObject("ADODB.Stream")

        Call objStream.Open
        Call objStream.WriteText(objMQMessage.Body)
        Call objStream.SetEOS
        objStream.Position = 0

        Call objRSRead.Open(objStream)
        Call objRSInsert.Open("tblBooks", k_strDSN, adOpenKeyset, adLockOptimistic, adCmdTable)

        Call objRSInsert.AddNew
        For Each objField In objRSRead.Fields
            If objField.Name <> "Id" Then
                objRSInsert(objField.Name) = objField.Value
            End If
        Next
        Call objRSInsert.Update

        Call objRSRead.Close
        Call objRSInsert.Close
        Call objStream.Close

        Call m_pIObjectContext.SetComplete
        Exit Sub

ErrorHandler:
    Call m_pIObjectContext.SetAbort

    If objRSRead.ActiveConnection.Errors.Count > 0 Then
        With objRSRead.ActiveConnection.Errors(0)
            Call Err.Raise(.Number, .Source, .Description)
        End With
    ElseIf objRSInsert.ActiveConnection.Errors.Count > 0 Then
        With objRSInsert.ActiveConnection.Errors(0)
            Call Err.Raise(.Number, .Source, .Description)
        End With
    Else
        With Err
            Call .Raise(.Number, .Source, .Description)
        End With
    End If

End Sub
